C This program generates the dummy variables coding for the factors
C in nested multivariate analysis of variance by canonical redundancy 
C analysis, using 1, 2, or 3 factors (one main factor, plus 0, 1, or 
C 2 nested factors).
C
C                                          Pierre Legendre, juillet 2002
C ----------------------------------------------------------------------
C2345678901234567890123456789012345678901234567890123456789012345678901234567890
C Parameters determining the maximum size of the data tables:
C    nmax = maximum number of objects (rows of all data files)
C    mmax = maximum n. of dummy var. in all files of anova factors combined
C    maxfileX = maximum number of files of anova factors

      Parameter (nmax=500,mmax=200,maxfileX=3)
      Integer m1(maxfileX),m2(maxfileX)
      Real*8 X(nmax,mmax),vecX(mmax)
C
C BBEdit is the 'creator' for output files
C      call F_Creator('R*ch')
C Preliminaires
    1 write(*,*) 'Francais: tapez (1)'
      write(*,*) 'English:  type  (2)'
      read(*,*) langue
      if((langue.lt.1).or.(langue.gt.2)) goto 1
      if(langue.eq.1) then
         write(*,120)
         write(*,121) nmax,mmax,maxfileX
         else
         write(*,220)
         write(*,221) nmax,mmax,maxfileX
         endif
C Fichier des parametres de simulation
      if(langue.eq.1) then
    2    write(*,*) 'Combien de facteurs dans l''analyse? (1, 2 ou 3)'
         read(*,*) nfact
         if((nfact.lt.1).or.(nfact.gt.3)) goto 2
         write(*,*)
    3    write(*,*) 
     +      'Combien de niveaux pour le facteur principal A (ordre 1)?'
         read(*,*) ia
         if(ia.le.0) goto 3
         if(nfact.ge.2) then
    4       write(*,*) 
     +      'Combien de niveaux pour le facteur emboite B (ordre 2)?'
            read(*,*) ib
            if(ib.le.0) goto 4
            endif
         if(nfact.ge.3) then
    5       write(*,*) 
     +      'Combien de niveaux pour le facteur emboite C (ordre 3)?'
            read(*,*) ic
            if(ic.le.0) goto 5
            endif
    6    write(*,*) 'Combien de repetitions par niveau ',
     +     'du facteur d''ordre le plus eleve?'
         read(*,*) nrep
         if(nrep.le.0) goto 6
    7    write(*,*)
         write(*,*) 
     +   '(1) Ecrire toutes les variables muettes dans un seul fichier',
     +   '(qui pourra eventuellement etre utilise comme X dans Canoco)'
         write(*,*) '(2) Creer un fichier par facteur ',
     +       '(fichiers prets pour le programme NesAnova)'
         read(*,*) nfich
         if((nfich.lt.1).or.(nfich.gt.2)) goto 7
         if(nfich.eq.1) then
            open(1,file='Mat_X.out',status='new')
            else
            if(nfact.ge.1) open(1,file='Mat_X1.out',status='new')
            if(nfact.ge.2) open(2,file='Mat_X2.out',status='new')
            if(nfact.ge.3) open(3,file='Mat_X3.out',status='new')
            endif
        else
   12    write(*,*) 'How many factors in the analysis? (1, 2 or 3)'
         read(*,*) nfact
         if((nfact.lt.1).or.(nfact.gt.3)) goto 12
         write(*,*)
   13    write(*,*) 'How many levels for main factor A (order 1)?'
         read(*,*) ia
         if(ia.le.0) goto 13
         if(nfact.ge.2) then
   14       write(*,*) 'How many levels for nested factor B (order 2)?'
            read(*,*) ib
            if(ib.le.0) goto 14
            endif
         if(nfact.ge.3) then
   15       write(*,*) 'How many levels for nested factor C (order 3)?'
            read(*,*) ic
            if(ic.le.0) goto 15
            endif
   16    write(*,*) 
     +     'How many replicates per level of the highest-order factor?'
         read(*,*) nrep
         if(nrep.le.0) goto 16
   17    write(*,*)
         write(*,*) '(1) Write all dummy variables to a single file ',
     +      '(it may be used as matrix X in Canoco)'
         write(*,*) '(2) Create a separate file for each factor ',
     +      '(files ready for program NesAnova)'
         read(*,*) nfich
         if((nfich.lt.1).or.(nfich.gt.2)) goto 17
         if(nfich.eq.1) then
            open(1,file='Mat_X.out',status='new')
            else
            if(nfact.ge.1) open(1,file='Mat_X1.out',status='new')
            if(nfact.ge.2) open(2,file='Mat_X2.out',status='new')
            if(nfact.ge.3) open(3,file='Mat_X3.out',status='new')
            endif
        endif
C
      call GenX(nfact,ia,ib,ic,nrep,X,vecX,m1,m2,n,m,
     +      nmax,mmax,maxfileX,0)
C
      if(nfich.eq.1) then
         if(langue.eq.1) write(*,103) n,m
         if(langue.eq.2) write(*,203) n,m
         write(1,116) n,m
         do i=1,n
            write(1,100) (X(i,j), j=1,m)
            enddo
         else
         if(langue.eq.1) write(*,104) n,m2(1)
         if(langue.eq.2) write(*,204) n,m2(1)
         write(1,116) n,m2(1)
         do i=1,n
            write(1,100) (X(i,j), j=1,m2(1))
            enddo
         if(nfact.ge.2) then
            mm=m2(2)-m2(1)
            write(2,116) n,mm
            if(langue.eq.1) write(*,105) n,mm
            if(langue.eq.2) write(*,205) n,mm
            do i=1,n
               write(2,100) (X(i,j), j=m1(2),m2(2))
               enddo
            endif
         if(nfact.ge.3) then
            mm=m2(3)-m2(2)
            write(3,116) n,mm
            if(langue.eq.1) write(*,106) n,mm
            if(langue.eq.2) write(*,206) n,mm
            do i=1,n
               write(3,100) (X(i,j), j=m1(3),m2(3))
               enddo
            endif
         endif
C
      write(*,115)
      if(nfich.eq.1) then
         if(langue.eq.1) write(*,107)
         if(langue.eq.2) write(*,207)
         else
         if(langue.eq.1) write(*,108)
         if(langue.eq.2) write(*,208)
         if(nfact.ge.2) then
            if(langue.eq.1) write(*,109)
            if(langue.eq.2) write(*,209)
            endif
         if(nfact.ge.3) then
            if(langue.eq.1) write(*,110)
            if(langue.eq.2) write(*,210)
            endif
         endif
      write(*,115)
C
      close(1)
      close(2)
      close(3)
      stop
  100 format(200f4.0)
  102 format(' Fact ',i1,5x,i2,3x,i2)
  103 format(/
     +' Il y a ',i5,' objets et ',i5,' variables muettes dans X')
  203 format(/
     +' There are ',i5,' objects and ',i5,' dummy variables in X')
  104 format(/
     +' Il y a ',i5,' objets et ',i5,' variables muettes dans X1')
  204 format(/
     +' There are ',i5,' objects and ',i5,' dummy variables in X1')
  105 format(/
     +' Il y a ',i5,' objets et ',i5,' variables muettes dans X2')
  205 format(/
     +' There are ',i5,' objects and ',i5,' dummy variables in X2')
  106 format(/
     +' Il y a ',i5,' objets et ',i5,' variables muettes dans X3')
  206 format(/
     +' There are ',i5,' objects and ',i5,' dummy variables in X3')
  107 format(/' Toutes les variables muettes se trouvent',
     +   ' dans le fichier "Mat_X.out"')
  207 format(/' All dummy variables have been written',
     +   ' to file "Mat_X.out"')
  108 format(/' Les variables muettes pour le facteur A se trouvent',
     +   ' dans le fichier "Mat_X1.out"')
  208 format(/' The dummy variables for factor A have been written',
     +   ' to file "Mat_X1.out"')
  109 format(/' Les variables muettes pour le facteur B se trouvent',
     +   ' dans le fichier "Mat_X2.out"')
  209 format(/' The dummy variables for factor B have been written',
     +   ' to file "Mat_X2.out"')
  110 format(/' Les variables muettes pour le facteur C se trouvent',
     +   ' dans le fichier "Mat_X3.out"')
  210 format(/' The dummy variables for factor C have been written',
     +   ' to file "Mat_X3.out"')
  115 format(/' ---------------')
  116 format(2i5)
  120 format(/' Ce programme genere les variables muettes codant pour'/
     +        ' les facteurs d''une analyse de variance hierarchique'/
     +        ' a 1, 2 ou 3 facteurs (un facteur principal,'/
     +        ' plus 0, 1 ou 2 facteurs emboites).'//
     +        ' Pierre Legendre'/
     +        ' Departement de sciences biologiques'/
     +        ' Universite de Montreal.'/
     +        '             (c) Pierre Legendre, 2002'/)
  121 format(/' Capacite maximale de ce programme:'/
     +        i7,' objets (lignes de touts les tableaux de donnees)'/
     +        i7,' variables muettes dans tous les fichiers X combines'/
     +        i7,' facteurs de l''anova'/)
  220 format(/' This program generates the dummy variables coding'/
     +        ' for the factors of a nested analysis of variance'/
     +        ' using 1, 2, or 3 factors (one main factor,'/
     +        ' plus 0, 1, or 2 nested factors).'//
     +        ' Pierre Legendre'/
     +        ' Departement de sciences biologiques'/
     +        ' Universite de Montreal.'/
     +        '             (c) Pierre Legendre, 2002'/)
  221 format(/' This program can handle a maximum of'/
     +        i7,' objects (rows of all data files)'/
     +        i7,' dummy var. in all files of anova factors combined'/
     +        i7,' anova factors'/)
      end

      Subroutine GenX(nfact,ia,ib,ic,nrep,X,vecX,m1,m2,n,m,
     +      nmax,mmax,maxfileX,idebug)
      Integer m1(maxfileX),m2(maxfileX)
      Real*8 X(nmax,mmax),vecX(mmax)
      if(nfact.eq.1) then
         n=ia*nrep
         nrep1=nrep
         m=ia-1
        else if(nfact.eq.2) then
         n=ia*ib*nrep
         nrep1=nrep*ib
         nrep2=nrep
         m=(ia-1)+ia*(ib-1)
        else if(nfact.eq.3) then
         n=ia*ib*ic*nrep
         nrep1=nrep*ib*ic
         nrep2=nrep*ic
         nrep3=nrep
         m=(ia-1)+ia*(ib-1)+ia*ib*(ic-1)
        endif
        if(n.gt.nmax) stop 'Too many objects. Redimension the program'
        if(m.gt.mmax) stop 
     +     'Too many dummy variables. Redimension the program'
C Initialize matrix X
      do i=1,n
         do j=1,m
            X(i,j)=0.0
            enddo
         enddo
C Factor A
      m1(1)=1
      m2(1)=(ia-1)
      icount=0
      do i1=1,ia
         do j=1,(i1-1)
            vecX(j)= -1.0
            enddo
         vecX(i1)=dfloat(ia-i1)
         do j=(i1+1),(ia-1)
            vecX(j)=0.0
            enddo
         do ir=1,nrep1
            icount=icount+1
            do j=1,(ia-1)
               X(icount,j)=vecX(j)
               enddo
            enddo
         enddo
      if(nfact.eq.1) return
C Factor B
      m1(2)=m2(1)+1
      m2(2)=m2(1)+ia*(ib-1)
      icount=0
      do i1=1,ia
         ibeg=m2(1)+((i1-1)*(ib-1))
         do i2=1,ib
            do j=1,(i2-1)
               vecX(j)= -1.0
               enddo
            vecX(i2)=dfloat(ib-i2)
            do j=(i2+1),(ib-1)
               vecX(j)=0.0
               enddo
            do ir=1,nrep2
               icount=icount+1
               do j=1,(ib-1)
                  X(icount,ibeg+j)=vecX(j)
                  enddo
               enddo
            enddo
         enddo
      if(nfact.eq.2) return
C Factor C
      m1(3)=m2(2)+1
      m2(3)=m2(2)+ia*ib*(ic-1)
      icount=0
      nblocs=-1
      do i1=1,ia
         do i2=1,ib
            nblocs=nblocs+1
            ibeg=m2(2)+nblocs*(ic-1)
            do i3=1,ic
               do j=1,(i3-1)
                  vecX(j)= -1.0
                  enddo
               vecX(i3)=dfloat(ic-i3)
               do j=(i3+1),(ic-1)
                  vecX(j)=0.0
                  enddo
               do ir=1,nrep3
                  icount=icount+1
                  do j=1,(ic-1)
                     X(icount,ibeg+j)=vecX(j)
                     enddo
                  enddo
               enddo
            enddo
         enddo
C
      return
      end
      
